//*****************************************
//*****************************************
// Numitron(IV-9) Clock Program Mega328
// CPU Clock:8MHz
//   iq[Yf[^@UWlgɂj
//
// file name: port_bit.c
//
//  2016/10/23  New(TAB4)  Taishi
//*****************************************

#include	<avr/io.h>

#include	"four_iv9_clock.h"
#include	"timer.h"
#include	"port_bit.h"


unsigned char	sw[4];							// SW[1] Ɍ݂̏ԁAĂ镨'1'̏ԁA SW[2] ɉꂽuԂ'1'̏ԁA SW[3] ɗꂽuԂ'1'̏
static	unsigned char	old_sw;
static	unsigned char	swr_continue_count;
static	unsigned char	swl_continue_count;
//***************************
//@XCb`̏ݒ
//***************************
void	sw_init(void)
{
	DDRD  &= ~((1 << DDD3)|(1 << DDD4));		// Port-D Bit3,4 : Intput
	PORTD |= ((1 << PD3)|(1 << PD4));			// PD3,4 Pullup

	swr_continue_count = 0;
	swl_continue_count = 0;
}
//***************************
//@XCb`Ԃ
// SW[1] Ɍ݂̏ԁAĂ镨'1'̏
// SW[2] ɉꂽuԂ'1'̏
//  Timer2 ̊荞݂gpĂԂKv
//***************************
void	get_sw(void)
{
	unsigned char	uc;

	if(tim_10ms_sw == 0){
		tim_10ms_sw = 3;									// ROrԊu
		uc = ((~PIND) & (SW_RIGHT | SW_LEFT));				// ]ăXCb`f[^擾
		if (old_sw == uc){									// OƓf[^̎
			sw[0] = sw[1];
			sw[1] = uc;
			sw[2] = ((sw[0] ^ sw[1]) & sw[1]);				// ꂽXCb`f[^
			sw[3] = ((sw[0] ^ sw[1]) & ~sw[1]);				// ꂽXCb`f[^
		}else{
			sw[2] = 0;
			sw[3] = 0;
		}
		old_sw = uc;										// Of[^ɓ
	}else{
		sw[2] = 0;
		sw[3] = 0;
	}
}
#define			TMR_LONG			100			// 10mSx100=1Sec ̎Ԗ͒ZԂƂ
#define			TMR_CONTIMUE		100			// 10mSx100=1Sec ꑱ@̊ԊuŁuSWR_ON_CONTINUEvɂȂ
#define			TMR_CONTIMUE2		50			// 10mSx50=500mS ꑱ̂Qxڈȍ~́uSWR_ON_CONTINUEvo^C~OɂȂ
#define			TML_LONG			100			// 10mSx100=1Sec ̎Ԗ͒ZԂƂ
#define			TML_CONTIMUE		100			// 10mSx100=1Sec ꑱ@̊ԊuŁuSWR_ON_CONTINUEvɂȂ
#define			TML_CONTIMUE2		50			// 10mSx50=500mS ꑱ̂Qxڈȍ~́uSWR_ON_CONTINUEvo^C~OɂȂ
//***************************
//@XCb`Ԃ
// SW[1] Ɍ݂̏ԁAĂ镨'1'̏
// SW[2] ɉꂽuԂ'1'̏
//  Timer2 ̊荞݂gpĂԂKv
//***************************
unsigned short	get_action_sw(void)
{
	unsigned short	us=0;

	get_sw();												// XCb`Ԃ

	if((sw[2] & SW_RIGHT) != 0){							// EXCb`nm̏uԂ̎
		us |= (SWR_ON_NOW | SWR_ON);
		tim_10ms_swr_continue = TMR_CONTIMUE;
		tim_10ms_swr_length = TMR_LONG;
		swr_continue_count = 1;
	}else if((sw[1] & SW_RIGHT) != 0){						// EXCb`nm̎
		us |= SWR_ON;
		if(tim_10ms_swr_continue == 0){						// ꑱo^C~O̎
			us |= SWR_ON_CONTINUE;
			if(swr_continue_count < 2){
				swr_continue_count++;
				tim_10ms_swr_continue = TMR_CONTIMUE;
			}else{
				tim_10ms_swr_continue = TMR_CONTIMUE2;
			}
		}
	}else if((sw[3] & SW_RIGHT) != 0){						// EXCb`ꂽuԂ̎
		if(tim_10ms_swr_length == 0){						// ꂽԂ
			us |= SWR_OFF_LONG;
		}else{												// ꂽԂZ
			us |= SWR_OFF_SHORT;
		}
		tim_10ms_swr_continue = 0;
		tim_10ms_swr_length = 0;
		swr_continue_count = 0;
	}else if((sw[1] & SW_RIGHT) == 0){						// EXCb`nee̎
		tim_10ms_swr_continue = 0;
		tim_10ms_swr_length = 0;
		swr_continue_count = 0;
	}

	if((sw[2] & SW_LEFT) != 0){								// XCb`nm̏uԂ̎
		us |= (SWL_ON_NOW | SWL_ON);
		tim_10ms_swl_continue = TML_CONTIMUE;
		tim_10ms_swl_length = TML_LONG;
		swl_continue_count = 1;
	}else if((sw[1] & SW_LEFT) != 0){						// XCb`nm̎
		us |= SWL_ON;
		if(tim_10ms_swl_continue == 0){						// ꑱo^C~O̎
			us |= SWL_ON_CONTINUE;
			if(swl_continue_count < 2){
				swl_continue_count++;
				tim_10ms_swl_continue = TML_CONTIMUE;
			}else{
				tim_10ms_swl_continue = TML_CONTIMUE2;
			}
		}
	}else if((sw[3] & SW_LEFT) != 0){						// XCb`ꂽuԂ̎
		if(tim_10ms_swl_length == 0){						// ꂽԂ
			us |= SWL_OFF_LONG;
		}else{												// ꂽԂZ
			us |= SWL_OFF_SHORT;
		}
		tim_10ms_swl_continue = 0;
		tim_10ms_swl_length = 0;
		swl_continue_count = 0;
	}else if((sw[1] & SW_LEFT) == 0){						// XCb`nee̎
		tim_10ms_swl_continue = 0;
		tim_10ms_swl_length = 0;
		swl_continue_count = 0;
	}

	return(us);
}

//*****************************************
// XCb`@܂ŉiv[v
//  XCb`͂Ɋ荞݃^C}[gB
//  Timer2 ̊荞݂gpĂԂKv
//*****************************************
void	wait_key_off(void)
{
	while(1){											// rv܂ő҂
		get_sw();										// XCb`Ԃ
		if( (sw[1] & (SW_RIGHT | SW_LEFT)) == 0 ){		// ꂽ
			break;
		}
	}
}
//*****************************************
// XCb`@܂ŉiv[v
//  XCb`rbǵA`^Op^C}[Ɂ@荞݂͎gȂ
//  \tgEFA^C}[gp
//*****************************************
void	wait_sw_off(void)
{
	while(1){
		if((PIND & (SW_RIGHT | SW_LEFT)) == (SW_RIGHT | SW_LEFT)){
			delay_ms(100);												// 100mS Delay
			if((PIND & (SW_RIGHT | SW_LEFT)) == (SW_RIGHT | SW_LEFT)){
				break;													// {ɗꂽƂ
			}
		}
	}
}

//***************************
//  LED̏ݒ
//***************************
void	led_init(void)
{
	DDRD  |= ((1 << DDD6)|(1<< DDD7));		// Port-D Bit6,7 : Output
	PORTD &= ~((1 << PD6)|(1 << PD6));		// PD6,7 Low

}
//***************************
//  LED3(Yellow)ON/OFF (DS3 Down side)
//  F  OneeijAPnmi_j
//***************************
void	led3_on_off(unsigned char on)
{
	if(on == 0){
		PORTD &= ~(1 << PD7);	// PD7 Low
	}else{
		PORTD |=  (1 << PD7);	// PD7 High
	}
}
//***************************
//  LED2(Yellow)ON/OFF (DS2 Up side)
//  F  OneeijAPnmi_j
//***************************
void	led2_on_off(unsigned char on)
{
	if(on == 0){
		PORTD &= ~(1 << PD6);	// PD6 Low
	}else{
		PORTD |=  (1 << PD6);	// PD6 High
	}
}

