//*****************************************
// Numitron(IV-9) Clock Program Mega328
// CPU Clock:8MHz
//   iq[Yf[^@UWlgɂj
//
// file name: pr_four_iv9_cloc.c
//
//
//  2016/10/23  New(TAB4)  Taishi
//  2016/12/26  Modify     Taishi 邳ݒǉ
//*****************************************


#include	<avr/interrupt.h>
#include	<avr/io.h>
#include	<avr/pgmspace.h>
#include	<avr/sleep.h>
#include	<avr/eeprom.h>
#include	<stdio.h>

#include	"four_iv9_clock.h"
#include	"uart.h"
#include	"timer.h"
#include	"disp_tlc5916_iv9.h"
#include	"rtc_DS3234.h"
#include	"port_bit.h"
#include	"ad_conv.h"
#include	"utl.h"


unsigned char	num_data[5]={0x01,0x02,0x03,0x04,0};			// S̐f[^
unsigned char	dp_data[5] ={0x00,0x00,0x00,0x00,0};			// S̏_f[^

enum DISP_CLOCK_MODE {		// 샂[h
		HM = 0,				// \
		MD,					// \
		YE,					// N\
		A_D,				// `^c\
		SET					// v킹
	};

// **********************************************************
// ********************** Soft Timer ************************
// **********************************************************

volatile unsigned int	wait_i;
volatile unsigned int	wait_j;
volatile unsigned char	wait_us;
// ************************************
// Delay 2uS
// t: uS (max 255)
// CPU Clock:8.000MHz
//  while ߂ for ŎԂ킹Ă
// ************************************
void delay_2us(unsigned char t)
{
	unsigned char	i;

	for(i=0;i<t;i++){
		wait_us++;				// 1uS Delay??
		wait_us++;				// 1uS Delay??
		wait_us++;				// 1uS Delay??
	}
}
//***************************
// Wait
//  tm : Wait Time(ms) max. 8000
// CPU Clock:8.000MHz
//***************************
void	delay_ms(int tm)
{

	for(wait_i = 0; wait_i < tm; wait_i++){
		delay_2us(500/2);
		delay_2us(500/2);
	}
}
//***************************
//  Main
//***************************
int	main(void)
{

	char			uc;
	unsigned short	us;
	unsigned short	ad_bright;
	unsigned short	bright_number=2;
	unsigned char	disp_clock_mode=HM;
	unsigned char	old_rtc_1s_flg=0xff;
	unsigned char	old_RTC_hou = 0xff;
	unsigned char	old_RTC_min = 0xff;
	unsigned char	old_RTC_mon = 0xff;
	unsigned char	old_RTC_day = 0xff;
	unsigned char	old_RTC_year = 0xff;
	unsigned short	old_AD_data = 0xffff;

	delay_ms(200);										// 200mS Delay
	sw_init();											//  XCb`̏ݒ
	led_init();											// LED̏ݒ

#ifdef	TEST_MODE
// test start
//DS2
	led2_on_off(1);										// LED2(Yellow)ON (DS2 Up side)
	delay_ms(500);										// 500mS Delay
	led2_on_off(0);										// LED2(Yellow)OFF (DS2 Up side)
	delay_ms(500);										// 500mS Delay
	led2_on_off(1);										// LED2(Yellow)ON (DS2 Up side)
	delay_ms(500);										// 500mS Delay
	led2_on_off(0);										// LED2(Yellow)OFF (DS2 Up side)
	delay_ms(500);										// 500mS Delay

//DS3
	led3_on_off(1);										// LED3(Yellow)ON (DS3 Up side)
	delay_ms(500);										// 500mS Delay
	led3_on_off(0);										// LED3(Yellow)OFF (DS3 Up side)
	delay_ms(500);										// 500mS Delay
	led3_on_off(1);										// LED3(Yellow)ON (DS3 Up side)
	delay_ms(500);										// 500mS Delay
	led3_on_off(0);										// LED3(Yellow)OFF (DS3 Up side)
	delay_ms(500);										// 500mS Delay
	led3_on_off(1);										// LED3(Yellow)ON (DS3 Up side)
	delay_ms(500);										// 500mS Delay
	led3_on_off(0);										// LED3(Yellow)OFF (DS3 Up side)
	delay_ms(500);										// 500mS Delay
// test end
#endif

	uart_init();										// UART Initial

	uart_tx_str_crlf(" ");								// UART TxD String + CR + LF
	uart_tx_str_crlf(__DATE__);							// UART TxD String + CR + LF
	uart_tx_str_crlf(__TIME__);							// UART TxD String + CR + LF
	uart_tx_str_crlf(__FILE__);							// UART TxD String + CR + LF

	uart_tx_str_crlf("Ecoh Start");						// UART TxD String + CR + LF

#ifdef	TEST_MODE
// test start
	while(1){
		if((PIND & SW_RIGHT) == 0){						// EXCb`Fnm
			led3_on_off(1);								// LED3(Yellow)ON (DS3 Up side)
		}else{
			led3_on_off(0);								// LED3(Yellow)OFF (DS3 Up side)
		}

		if((PIND & SW_LEFT) == 0){						// XCb`Fnm
			led2_on_off(1);								// LED2(Yellow)ON (DS2 Up side)
		}else{
			led2_on_off(0);								// LED2(Yellow)OFF (DS2 Up side)
		}
		if((PIND & (SW_RIGHT | SW_LEFT)) == 0){			// XCb`Fnm
			break;
		}
	}
// test end
#endif

// VZO\
	init_7seg();										//  VZOp̏ݒ
	chang_7seg_data(num_data,dp_data);					//  VZOf[^֕ϊS
	disp_7seg();										//  VZO̕\
	set_7seg_enable();									//  VZO\̗L̃Zbg

	sw_init();											//  XCb`̏ݒ
	led_init();											//  LED̏ݒ
	rtc_init();											//  qsb̏ݒ
	ad1_init();											// A/D 1 Initial
	Timer2_init();										// Timer2 Initial

	tim_10ms_led = 50;									// kdcpPOrPʃ^C}[
	sei();												// 荞݉

	while(1){
		if(Get_rxd((unsigned char *)(&uc)) != 0){				// MiGR[obNj
			uart_tx_one(uc);									// UART TxD One Char
		}
		us = get_action_sw();									// XCb`Ԃ
		us = us & (SWR_MASK | SWL_MASK);						// XCb`ɂ
		if(us == (SWR_OFF_SHORT)){								// E(SET)Zꂽ
			proc_no_key_timeup(1);								// L[͂L
			disp_clock_mode = SET;
			proc_set_rtc();										// v킹
			disp_clock_mode = HM;
			old_RTC_hou = 0xff;
			old_RTC_min = 0xff;
			old_rtc_1s_flg = (rtc_1s_flg - 1);
		}else if(us == SWL_OFF_SHORT){							// (SELECT)Zꂽ
			proc_no_key_timeup(1);								// L[͂L
			switch(disp_clock_mode){							// 샂[hύX
			 case HM:
				disp_clock_mode = MD;
				old_RTC_mon = 0xff;
				old_RTC_day = 0xff;
				break;
			 case MD:
				disp_clock_mode = YE;
				old_RTC_year = 0xff;
				break;
			 case YE:
				disp_clock_mode = A_D;
				old_AD_data = 0xffff;
				break;
			 case A_D:
				disp_clock_mode = HM;
				old_RTC_hou = 0xff;
				old_RTC_min = 0xff;
				break;
			 default:
				disp_clock_mode = HM;
				old_RTC_hou = 0xff;
				old_RTC_min = 0xff;
				break;
			}
			old_rtc_1s_flg = (rtc_1s_flg - 1);					// ɕ\
		}else{
			if(rtc_1s_flg != old_rtc_1s_flg){					// qsbĂ鎞̂Pboߗp
				old_rtc_1s_flg = rtc_1s_flg;
				ad_bright = ad1_get_data();						// A/D1i邳j 擾
				if(disp_clock_mode == A_D){						// `cf[^\̎
					if(old_AD_data != ad_bright){				// `^cf[^ω
						wtod_04bcd(num_data, ad_bright);
						chang_7seg_data(num_data,dp_data);		//  VZOf[^֕ϊS
						disp_7seg();							//  VZO̕\
						old_AD_data = ad_bright;
					}
				}else{
					rtc_read();										// RTC ǂݏo
					if(disp_clock_mode == HM){						// \̎
						tim_10ms_led = 50;							// TOOr^C}[d|
						set_7seg_dp(1, 1);							// kdc_
						if((old_RTC_hou != gRTC_hou)||(old_RTC_min != gRTC_min)){	// ω
							set_7seg_data(gRTC_hou >> 4,0,0);		// \
							set_7seg_data(gRTC_hou & 0x0f,1,1);
							set_7seg_data(gRTC_min >> 4,0,2);		// \
							set_7seg_data(gRTC_min & 0x0f,0,3);
							old_RTC_hou = gRTC_hou;
							old_RTC_min = gRTC_min;
						}
						disp_7seg();								//  VZO̕\
					}else if(disp_clock_mode == MD){				// \̎
						if((old_RTC_mon != gRTC_mon)||(old_RTC_day != gRTC_day)){	// ω
							set_7seg_data(gRTC_mon >> 4,0,0);		// \
							set_7seg_data(gRTC_mon & 0x0f,1,1);
							set_7seg_data(gRTC_day >> 4,0,2);		// \
							set_7seg_data(gRTC_day & 0x0f,0,3);
							old_RTC_mon = gRTC_mon;
							old_RTC_day = gRTC_day;
							disp_7seg();							//  VZO̕\
						}
					}else if(disp_clock_mode == YE){				// N\̎
						if(old_RTC_year != gRTC_year){				// Nω
							set_7seg_data(2,0,0);
							set_7seg_data(0,0,1);
							set_7seg_data(gRTC_year >> 4,0,2);		// N\
							set_7seg_data(gRTC_year & 0x0f,0,3);
							old_RTC_year = gRTC_year;
							disp_7seg();							//  VZO̕\
						}
					}
				}

				if (proc_no_key_timeup(0) == 0xff){				// ԃL[͂
					if(disp_clock_mode != HM){					// \Ŗ
						disp_clock_mode = HM;
						old_RTC_hou = 0xff;
						old_RTC_min = 0xff;
					}
				}

				if(bright_number == 2){
					if(BRIGHT_HIGH_to_MIDDLE < ad_bright){		// ͂炢
						bright_number = 1;
						set_7seg_bright(bright_number);			// VZO\̖邳ݒi炢j
					}
				}else if(bright_number == 1){
					if(ad_bright < BRIGHT_MIDDLE_to_HIGH){		// ͂邢
						bright_number = 2;
						set_7seg_bright(bright_number);			// VZO\̖邳ݒiԖ邢j
					}else if(BRIGHT_MIDDLE_to_LOW < ad_bright){	// ͂Â
						bright_number = 0;
						set_7seg_bright(bright_number);			// VZO\̖邳ݒiԈÂj
					}
				}else{
					if(ad_bright < BRIGHT_LOW_to_MIDDLE){		// ͂炢
						bright_number = 1;
						set_7seg_bright(bright_number);			// VZO\̖邳ݒi炢j
					}
				}
			}

			if((tim_10ms_led == 0) && (disp_clock_mode == HM)){	// \̎ɂTOOro߂
				set_7seg_dp(0, 1);								// kdc
				disp_7seg();									//  VZO̕\
			}
		}
		sleep_mode();											// X[vڍs
	}
}
